<?php 
function process_template($template,$vararray,$before) {

        $output=explode("\n",$template);

        $vars=array_keys($vararray);

        foreach ($vars as $key) {
            $i=0;
            foreach ($output as $outputline) {
                if (ereg("#".$key."#",$outputline)) {
                        if ($vararray[$key]) {
				//support for multiline fields: according to the ReDIF standard
				// each new line has to start with a space ...
				$thisvararray=explode("\n",$vararray[$key]);
				if (count($thisvararray)>1 && $key!='author_template' && $key!='file_template') {
					$j=0; $vararray[$key]=$thisvararray[0];
					foreach ($thisvararray as $thisvarline) {
                                                if ($key=="Abstract" && $thisvarline=="") $sep="\n";      
                                                        else $sep="\n ";
                                                if ($j!=0) $vararray[$key]=$vararray[$key].$sep.$thisvarline;
						$j++;
						}
					} 
				
                              $output[$i]=str_replace("#".$key."#",$vararray[$key],$output[$i]);
				}
                         else $output[$i]="";
                              }
                $i++;
                }
           }

        foreach($output as $outputline) {
                if ($outputline)
                        $result=$result.$outputline."\n";
                }
	return $before.$result;
}


function make_rdf_date($datestring) {

        $year= (integer) substr($datestring,0,4);
        $month= (integer) substr($datestring,4,2);
        $day= (integer) substr($datestring,6,2);
	$newdate=$year."-".$month."-".$day;
	return $newdate;
}

function generate_series_rdf() {
   global $db_host, $db_user, $db_pass, $db_name;
   global $series_template;
   $srdf="";

   $archive=load_archive();

   $connection = mysql_connect($db_host, $db_user, $db_pass) or die
                          ("Unable to connect!");
   $query = "SELECT *
             FROM wp_series
             ORDER BY Name";

   mysql_select_db($db_name);
   $result = mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

   while ($series = mysql_fetch_array($result, MYSQL_ASSOC)) {

	// add to series rdf text
    	$series['Handle']="RePEc:".$archive['Handle'].":".$series['Handle'];
	
	$srdf=process_template($series_template,$series,$srdf);

	$srdf=$srdf."\n";
	}

    mysql_free_result($result);
    mysql_close($connection);

    return $srdf;
}

function generate_archive_rdf() {
   global $db_host, $db_user, $db_pass, $db_name;
   global $archive_template;
   $ardf="";

   $archive = load_archive();

   // add to archive rdf
    $archive['Handle']="RePEc:".$archive['Handle'];

    $ardf=process_template($archive_template,$archive,$ardf);

   return $ardf;
}

function generate_papers_rdf($ser_handle) {
   global $db_host, $db_user, $db_pass, $db_name;
   global $paper_template, $author_template, $file_template;
  $prdf="";

   $archive=load_archive();

   $connection = mysql_connect($db_host, $db_user, $db_pass) or die
                          ("Unable to connect!");
   $query = "SELECT *
             FROM wp_series
             WHERE Handle='$ser_handle'";

   mysql_select_db($db_name);
   $result = mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

   $series = mysql_fetch_array($result, MYSQL_ASSOC);
    mysql_free_result($result);

   $query = "SELECT *
             FROM wp_papers
	     WHERE ser_id='".$series['ser_id']."' 
	     AND enable='y'  
             ORDER BY ".$series['repec_sort']." ".$series['repec_sort_mode'].", Title";

   mysql_select_db($db_name);
   $result = mysql_query($query, $connection) or die ("Error in
                         query: $query. " . mysql_error());

   while ($paper = mysql_fetch_array($result, MYSQL_ASSOC)) {
 
        // add to papers rdf text
        $paper['Handle']="RePEc:".$archive['Handle'].":".$series['Handle'].":".$paper['Handle'];
	if ($paper['Creation_Date']) $paper['Creation_Date']=make_rdf_date($paper['Creation_Date']);
	if ($paper['Revision_Date']) $paper['Revision_Date']=make_rdf_date($paper['Revision_Date']);

		$autemplate="";
                $auarray=explode("!-!",$paper['authors']);
                $i=0;      
                foreach ($auarray as $thisau) {
		   if ($thisau) {
			$author="";
                	$tau=explode(";-;",$thisau);
          		$author['Name']=$tau[0];
          		$author['Email']=$tau[1];
          		$author['Homepage']=$tau[2];
          		$author['Workplace_Name']=$tau[3];
          		$author['Workplace_Homepage']=$tau[4];
			$autemplate=process_template($author_template,$author,$autemplate);
			$autemplate=$autemplate."\n";
		        }
                }

	$paper['author_template']=$autemplate;

                $fitemplate="";
                $fiarray=explode("!-!",$paper['files']);
                $i=0;
                foreach ($fiarray as $thisfi) {
                   if ($thisfi) {
                        $file="";
                        $tau=explode(";-;",$thisfi);
                        if (eregi("http://",$tau[0])) $file['URL'] = $tau[0];
                                else $file['URL']=$series['default_download_url']."/".$tau[0];
                        $file['Format']=$tau[1];
                        $file['Restriction']=$tau[2];
                        $file['Function']=$tau[3];
                        $file['Size']=$tau[4];
                        $fitemplate=process_template($file_template,$file,$fitemplate);
                        $fitemplate=$fitemplate."\n";
                        }
                }

        $paper['file_template']=$fitemplate;


	$prdf=process_template($paper_template,$paper,$prdf);

        $prdf=$prdf."\n";
        }

    mysql_free_result($result);
    mysql_close($connection);

   return $prdf;
}


function get_indexcontent() {

$content='<?php
echo "<HTML><BODY><pre>
";
$handle=opendir(".");
while ($file = readdir ($handle)) {
    if ($file != "." && $file != ".." && $file !="index.php") {
        if (is_dir("./".$file)) $dirs[]=$file; else $files[]=$file;
    }
}
closedir($handle);

if (count($files)>0) {
        sort($files);
        foreach ($files as $filename) {
                echo "<A HREF=\"".$filename."\">".$filename."</A>";
                echo "\n";
                }
        }

if (count($dirs)>0) {
        sort($dirs);
        foreach ($dirs as $dirname) {
                echo "<A HREF=\"".$dirname."/\">".$dirname."/</A>";
                echo "\n";
                }
        }

echo "</pre></BODY></HTML>";
?>';

return $content;
}

?>
